using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            ModAPI.RegisterTool<TimeTool>(
                "Time tool",
                "When selected, you can alter the speed of time!",
                ModAPI.LoadSprite("tool.png")
                );
        }
    }
    public class TimeTool : ToolBehaviour
    {
        public DialogBox dialog = (DialogBox)null;
        public float speed = 1;
        public bool enabled = false;
        public override void OnToolChosen()
        {
            dialog = DialogBoxManager.TextEntry("Enter time scale (1 = normal, 2 = 2x speed)", "Time Scale", new DialogButton("Apply", true, new UnityAction[1]
            {
                            (UnityAction)(() =>
                            {
                                speed = float.Parse(dialog.EnteredText);
                            })
            }),
            new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            ;
        }
        private void FixedUpdate()
        {
            if (enabled)
            {
                Time.timeScale = speed;
            }
        }
        public override void OnToolUnchosen()
        {
            enabled = false;
        }

        public override void OnSelect()
        {
            ModAPI.Notify("Current speed = " + speed);
        }

        public override void OnHold()
        {
            enabled = true;
        }

        public override void OnFixedHold()
        {
            //Gets invoked for every FixedUpdate an object is held while this tool is equipped
        }

        public override void OnDeselect()
        {
            enabled = false;
        }
    }
}